#ifndef KPH_H
#define KPH_H

// vm



NTSTATUS KphCopyVirtualMemory(
							  __in PEPROCESS FromProcess,
							  __in PVOID FromAddress,
							  __in PEPROCESS ToProcess,
							  __in PVOID ToAddress,
							  __in SIZE_T BufferLength,
							  __in KPROCESSOR_MODE AccessMode,
							  __out PSIZE_T ReturnLength
							  );

NTSTATUS KpiReadVirtualMemory(
							  __in HANDLE ProcessHandle,
							  __in PVOID BaseAddress,
							  __out_bcount(BufferSize) PVOID Buffer,
							  __in SIZE_T BufferSize,
							  __out_opt PSIZE_T NumberOfBytesRead,
							  __in KPROCESSOR_MODE AccessMode
							  );

NTSTATUS KpiWriteVirtualMemory(
							   __in HANDLE ProcessHandle,
							   __in_opt PVOID BaseAddress,
							   __in_bcount(BufferSize) PVOID Buffer,
							   __in SIZE_T BufferSize,
							   __out_opt PSIZE_T NumberOfBytesWritten,
							   __in KPROCESSOR_MODE AccessMode
							   );

NTSTATUS KpiReadVirtualMemoryUnsafe(
									__in_opt HANDLE ProcessHandle,
									__in PVOID BaseAddress,
									__out_bcount(BufferSize) PVOID Buffer,
									__in SIZE_T BufferSize,
									__out_opt PSIZE_T NumberOfBytesRead,
									__in KPROCESSOR_MODE AccessMode
									);


#endif
