#ifndef _DRIVERCTRL_H__
#define _DRIVERCTRL_H__

#include <stdio.h>
#include <Windows.h>
#include "resource.h"
#include "Misc.h"
#include "..\common\common.h"

/************************************************************************/
/*     miniFilter                                           */
/************************************************************************/
#include <fltUser.h>

// #pragma comment(lib, "user32.lib")
// #pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "fltLib.lib")
#pragma comment(lib, "fltMgr.lib")
// #pragma comment(lib, "ntoskrnl.lib")
// #pragma comment(lib, "hal.lib")


int InitialCommunicationPort(void);
int FLSendMessage(PVOID InputBuffer);

#define MINI_DRVNAME			"FLPROF.sys"
#define NPMINI_NAME            "FLPROF"
#define NPMINI_PORT_NAME       L"\\FLProfPort"

typedef enum _NPMINI_COMMAND {
	ENUM_PASS = 0,
	ENUM_BLOCK
} NPMINI_COMMAND;

typedef struct _COMMAND_MESSAGE {
	NPMINI_COMMAND 	Command;  
} COMMAND_MESSAGE, *PCOMMAND_MESSAGE;

DWORD GetProcessListByDrv(DWORD& pid, ULONGLONG& SerBase);


void * IOCTLReadKernMem( HANDLE, READ_KERN_MEM_t * );
int LoadDriver( HANDLE * );
int UnloadDriver( HANDLE * );
BOOL FLConnectEx(PCHAR DeviceName);

//miniFilter
BOOL InstallDrvByInf( char* lpszDriverName);
BOOL InstallDriver(const char* lpszDriverName, char* lpszDriverPath,const char* lpszAltitude);
BOOL StartDriver(const char* lpszDriverName);
BOOL StopDriver(const char* lpszDriverName);
BOOL DeleteDriver(const char* lpszDriverName);

#endif