#include "LifeDll.h"

struct LifeDefenseFunAPIStu
{
	void *Start;
	void *Stop;
	void *UnInstall;
	void *FLSvcProtectOn;
	void *FLSvcProtectOff;
	void *FLSvcProtectCtrl;
	void *FLFilesProtectCtrl;
};
LifeDefenseFunAPIStu LifeDefenseFunApiStu;

void * LifeDefenseFunAPI()
{

	LifeDefenseFunApiStu.Start = (void*)&Start;
	LifeDefenseFunApiStu.Stop = (void*)&Stop;
	LifeDefenseFunApiStu.UnInstall = (void*)UnInstall;
	LifeDefenseFunApiStu.FLSvcProtectOn = (void*)&FLSvcProtectOn;
	LifeDefenseFunApiStu.FLSvcProtectOff = (void*)&FLSvcProtectOff;
	LifeDefenseFunApiStu.FLSvcProtectCtrl = (void*)&FLSvcProtectCtrl;
	LifeDefenseFunApiStu.FLFilesProtectCtrl = (void*)&FLFilesProtectCtrl;
	return &LifeDefenseFunApiStu;
};

extern OFFSETS Offsets;

BOOL Start()
{
	__try
	{
		EnableDebugPrivilege();
		CheckOSVersion();

		if( Offsets.isX64)
		{
			//1
			if(LoadDriver(&g_device) == FALSE)
				return FALSE;

			if( InstallDrvByInf(MINI_DRVNAME)== FALSE)
				return FALSE;
		}
		else
		{
			if( Init2UndocApi() == FALSE)
				return FALSE;

			g_ObReferenceObjectByHandle = GetKernelExportFuncAddr("ObReferenceObjectByHandle");
			if(g_ObReferenceObjectByHandle == NULL)
				return FALSE;

			//1
			if(LoadDriver(&g_device) == FALSE)
				//	if( FLConnectEx(SERVICE_NAME) == FALSE)
				return FALSE;


			//װminiFlter
			//InstallDriver(NPMINI_NAME,MINI_DRVNAME,"370030");
			if( InstallDrvByInf(MINI_DRVNAME)== FALSE)
				return FALSE;
		}


	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	return TRUE;
}

extern HANDLE g_hPort;

BOOL Stop()
{

	//Stopرվ
	//
	//

	CloseHandle(g_device);
	CloseHandle(g_hPort);
	return TRUE;

	
	BOOL retv = FALSE;
	char buff[512] = {0};
	READ_KERN_MEM_t read_kern_m = {0};
	read_kern_m.dst_address = buff;
	read_kern_m.type = SYM_TYP_NULL;
	read_kern_m.size = 8;

	__try
	{

		if(g_device == INVALID_HANDLE_VALUE || g_device == NULL)
		{
			 g_device = CreateFileA(
				NAMEOF_DEVICE,
				GENERIC_READ | GENERIC_WRITE,
				0, 
				NULL,
				OPEN_EXISTING,
				0,
				NULL
				);
			 if( g_device == INVALID_HANDLE_VALUE)
			 {
				 FLDRV_ERROR("No device handle,the device driver Not install.");
				 retv = TRUE;
				 goto clean;
			 }
			
		}

		if(g_ObReferenceObjectByHandle == NULL)
		{
			Init2UndocApi();
			g_ObReferenceObjectByHandle = GetKernelExportFuncAddr("ObReferenceObjectByHandle");
			if(g_ObReferenceObjectByHandle == NULL)
			{
				FLDRV_ERROR("g_ObReferenceObjectByHandle have no value!");
				goto clean;
			}
			
		}

		//ObReferenceObjectByHandleǷhook
		read_kern_m.src_address = (void*)g_ObReferenceObjectByHandle;
		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL ERROR");
			goto clean;
		}

		if(DisasmInspectBuffer((char*)read_kern_m.dst_address) == FALSE)
		{
			FLDRV_ERROR("ObReferenceObjectByHandle HAS  BEEN HOOK! Must Unhook it before UnLoad driver.");

// 			read_kern_m.type = SYM_TYP_UNHOOK_OBR;
// 			if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
// 			{
// 				FLDRV_ERROR("IOCTRL ERROR");
// 			}

			goto clean;
		}

		//ĵַ
		/*
		*/

		if(UnloadDriver(&g_device) == FALSE)
		{
			FLDRV_ERROR("UnLoadDriver Error");
		}

		if( StopDriver(NPMINI_NAME) == FALSE)
		{
			FLDRV_ERROR("Stop FlprofDriver Error");
		}

		if( DeleteDriver(NPMINI_NAME) == FALSE)
		{
			FLDRV_ERROR("Delete FlprofDriver Error");
		}
		retv = TRUE;


clean:
		NULL;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();

	return retv;
}

void UnInstall()
{
	//ֹͣɾ 
	StopDriver(SERVICE_NAME);
	StopDriver(NPMINI_NAME);

	DeleteDriver(SERVICE_NAME);
	DeleteDriver(NPMINI_NAME);
}



BOOL FLSvcProtectOn()
{
	BOOL retv = FALSE;
	char buff[512] = {0};
	READ_KERN_MEM_t read_kern_m = {0};
	read_kern_m.dst_address = buff;
	read_kern_m.type = SYM_TYP_NULL;
	read_kern_m.size = 8;
	read_kern_m.pid = GetCurrentProcessId();

	read_kern_m.offset.isSupported = Offsets.isSupported;
	read_kern_m.offset.KPROCESS = Offsets.KPROCESS;
	read_kern_m.offset.UniquePid = Offsets.UniquePid;
	read_kern_m.offset.ImgFileName = Offsets.ImgFileName;

	__try
	{
		if(g_device == INVALID_HANDLE_VALUE)
		{
			FLDRV_ERROR("No device handle, need load driver.");
			goto clean;
		}

		if(g_ObReferenceObjectByHandle == NULL)
		{
			FLDRV_ERROR("g_ObReferenceObjectByHandle have no value!");
			goto clean;
		}

		//ObReferenceObjectByHandleǷûhook
		read_kern_m.src_address = (void*)g_ObReferenceObjectByHandle;
		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL ERROR");
			goto clean;
		}

		if(DisasmInspectBuffer((char*)read_kern_m.dst_address) == FALSE)
		{
			FLDRV_ERROR("ObReferenceObjectByHandle HAS BEEN HOOK!Rehook it");

			read_kern_m.type = SYM_TYP_HOOK_OBR;
			if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
			{
				FLDRV_ERROR("IOCTRL ERROR");
			}
			retv = TRUE;

			goto clean;
		}

		//ĵַ
		/*
		*/


		read_kern_m.type = SYM_TYP_HOOK_OBR;
		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL ERROR");
		}
		retv = TRUE;

clean:
		NULL;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();
	return retv;
}


BOOL FLSvcProtectOff()
{
	BOOL retv = FALSE;
	char buff[512] = {0};
	READ_KERN_MEM_t read_kern_m = {0};
	read_kern_m.dst_address = buff;
	read_kern_m.type = SYM_TYP_NULL;
	read_kern_m.size = 8;

	__try
	{
		if(g_device == INVALID_HANDLE_VALUE)
		{
			FLDRV_ERROR("No device handle, need load driver.");
			goto clean;
		}

		if(g_ObReferenceObjectByHandle == NULL)
		{
			FLDRV_ERROR("g_ObReferenceObjectByHandle have no value!");
			goto clean;
		}

		//ObReferenceObjectByHandleǷhook
		read_kern_m.src_address = (void*)g_ObReferenceObjectByHandle;
		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL ERROR");
			goto clean;
		}

		if(DisasmInspectBuffer((char*)read_kern_m.dst_address) == TRUE)
		{
			FLDRV_ERROR("ObReferenceObjectByHandle has NOT been hook!");
			goto clean;
		}

		//ĵַ
		/*
		*/


		read_kern_m.type = SYM_TYP_UNHOOK_OBR;
		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL ERROR");
			goto clean;
		}
		return TRUE;

clean:
		retv = FALSE;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
		OARK_EXCEPTION();
	return retv;
}


BOOL FLSvcProtectCtrl(BOOL bProtect)
{
	BOOL retv = FALSE;
	READ_KERN_MEM_t read_kern_m = {0};
	DWORD PidServices = 0;
	PDWORD pEprocessServices = NULL;
	DWORD SrvDataBase = NULL;

	ULONGLONG SrvBase64 = NULL;
	ULONGLONG SrvDataBase64 = NULL;

	//
	// ڴС 
	//
	int SerCount = GetServiceCount();
	if( !SerCount)
	{
		FLDRV_ERROR("ZERO ServiceCount");
		return FALSE;
	}
	printf("ServiceCount:%d\n",SerCount);

	DWORD SrvBuffSize = SerCount*600;
	char* pBuffer = (char*)malloc(SrvBuffSize);
	memset(pBuffer,0,SrvBuffSize);

	if( Offsets.isX64)
	{
		GetProcessListByDrv(PidServices,SrvBase64);//ȡpid, ַ
		printf("Pid:%d, Services base:%I64X\n",PidServices,SrvBase64);


		GetServiceDataBaseWoW64(SrvBase64, SrvDataBase64); 	//services.exe ҵServiceDatabase

		if( SrvDataBase64 == NULL)
		{
			FLDRV_ERROR("Can not Get ServiceDatabase");
			return FALSE;
		}
		printf("SrvDataBase:%I64X\n",SrvDataBase64);

		//SrvDataBase64ڴbuffer
		read_kern_m.dst_address = pBuffer;
		read_kern_m.pid = PidServices;
		read_kern_m.size = 0x100;
		read_kern_m.src_address = 0;
		read_kern_m.ll_address = SrvDataBase64;
		read_kern_m.type = SYM_TYP_READWITHSTACKATTACH;

		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL_ERROR.");
		}

		//ӡ
		printf("buffer:%08x\n",pBuffer);
		hexdump(pBuffer,16*12);

		//
		// ServiceDatabase ַѾBuffer , Ҫƫ +0x8 (XP-X64) +0x80(WIN7-X64)ֵ
		//
		ULONGLONG ptr = read8_little_endian((unsigned char*)(pBuffer + Offsets.ServiceDatabase));
		if( ptr == 0)
		{
			return FALSE;
		}
		printf("ptr = %I64X\n",ptr);

		//
		// ׵ַ׵ַʼһƬڴ汩FLServier
		//
		read_kern_m.dst_address = pBuffer;
		read_kern_m.pid = PidServices;
		read_kern_m.size = SrvBuffSize;
		read_kern_m.src_address = 0;
		read_kern_m.ll_address = ptr;
		read_kern_m.type = SYM_TYP_READWITHSTACKATTACH;

		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL_ERROR.");
		}

		//ӡ
		printf("Srv list buffer:%08x\n",pBuffer);
		hexdump(pBuffer,16*12);

		//ʼ
		void *found = memmem(pBuffer,SrvBuffSize,L"FLService",18);
		printf("found:%08x\n",found);
		if(found == NULL)
		{
			FLDRV_ERROR("Can not find FLService\n");
			return FALSE;
		}

		DWORD offset = (DWORD)found - (DWORD)pBuffer;
		ULONGLONG FLSaddr = ptr + offset;
		printf("FLSaddr = %I64X\n",FLSaddr);
		FLSaddr -= Offsets.Acept_Name;//Accept_Controlֵ
		printf("FLSaddr Accept_Control = %I64X\n",FLSaddr);
		//
		// ѾõAccept_Controlĵַ ͨд0  1 
		//
		char FControl[] = {0x00,0x00,0x00,0x00};//
		char TControl[] = {0x01,0x00,0x00,0x00};//
		read_kern_m.src_address = bProtect > 0 ? FControl: TControl;
		read_kern_m.dst_address = (void*)0x123456;
		read_kern_m.ll_address = FLSaddr;
		read_kern_m.pid = PidServices;
		read_kern_m.size = 4;
		read_kern_m.type = SYM_TYP_WRITEUSERMEM;

		if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
		{
			FLDRV_ERROR("IOCTRL_ERROR.");
		}

		free(pBuffer);

		return TRUE;
	}
	else
	{
		PidServices = GetPid(L"services.exe");

		SrvDataBase = GetServiceDataBase(0); 	//services.exe ҵServiceDatabase

		if(SrvDataBase == NULL)
		{
			FLDRV_ERROR("Can not Get ServiceDatabase");
			return FALSE;
		}
		printf("SrvDataBase:%08x\n",SrvDataBase);
	}
	




//	pEprocessServices = PID2Eprocess(g_device,PidServices);
//	if(pEprocessServices == NULL)
//	{
//		FLDRV_ERROR("Couldn't obtain eprocess pointer");
//	}

	//ں˶ȡĵַ
	read_kern_m.dst_address = pBuffer;
	read_kern_m.pid = PidServices;
	read_kern_m.size = 100;
	read_kern_m.src_address = (void*)SrvDataBase;
	read_kern_m.type = SYM_TYP_READWITHSTACKATTACH;

	if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
	{
		FLDRV_ERROR("IOCTRL_ERROR.");
	}

	//ӡ
	printf("buffer:%08x\n",pBuffer);
	hexdump(pBuffer,16*8);

	//SERVICE_TABLE
	DWORD ptr = read4_little_endian((unsigned char*)(pBuffer + Offsets.ServiceDatabase));
	printf("ptr = %08x\n",ptr);

	//ڴȡbuffer
	memset(pBuffer,0,SrvBuffSize);
	read_kern_m.dst_address = pBuffer;
	read_kern_m.pid = PidServices;
	read_kern_m.size = SrvBuffSize;
	read_kern_m.src_address = (void*)ptr;
	read_kern_m.type = SYM_TYP_READWITHSTACKATTACH;

	if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
	{
		FLDRV_ERROR("IOCTRL_ERROR.");
	}

	//ӡ
	hexdump(pBuffer,100);

	//ڴбFLService
	void *found = memmem(pBuffer,SrvBuffSize,L"FLService",18);
	printf("found:%08x",found);
	if(found == NULL)
	{
		FLDRV_ERROR("Can not find FLService\n");
		return FALSE;
	}

	DWORD offset = (DWORD)found - (DWORD)pBuffer;
	DWORD FLSaddr = ptr + offset;
	printf("FLSaddr = %08x",FLSaddr);
	FLSaddr -= Offsets.Acept_Name;//Accept_Controlֵ

	char FControl[] = {0x00,0x00,0x00,0x00};//
	char TControl[] = {0x01,0x00,0x00,0x00};//
	read_kern_m.src_address = bProtect > 0 ? FControl: TControl;
	read_kern_m.dst_address = (void*)FLSaddr;
	read_kern_m.pid = PidServices;
	read_kern_m.size = 4;
	read_kern_m.type = SYM_TYP_WRITEUSERMEM;

	if(IOCTLReadKernMem(g_device, &read_kern_m) == NULL)
	{
		FLDRV_ERROR("IOCTRL_ERROR.");
	}
	retv = TRUE;

	free(pBuffer);

	return retv;
}

//װĿ¼µ(EXE DLL)ļ
BOOL FLFilesProtectCtrl(BOOL bProtected)
{
	COMMAND_MESSAGE data;
	data.Command = bProtected > 0 ? ENUM_BLOCK : ENUM_PASS;

	int retv = FLSendMessage((PVOID)&data);

	if(retv != S_OK)
	{
		FLDRV_ERROR("FLSendMessage fail");
		return FALSE;
	}
		return TRUE;
}



