#ifndef _MODULES_H_
#define _MODULES_H_

#include "Misc.h"
#include "MemSearch.h"

typedef struct
{
	ULONG Reserved1;
	ULONG Reserved2;
	PVOID ImageBaseAddress;
	ULONG ImageSize;
	ULONG Flags;
	WORD Id;
	WORD Rank;
	WORD w018;
	WORD NameOffset;
	BYTE Name[256];
} SYSTEM_MODULE, *PSYSTEM_MODULE;

#pragma warning(disable:4200)
typedef struct
{
	ULONG ModulesCount;
	SYSTEM_MODULE Modules[0];
} SYSTEM_MODULE_INFORMATION, *PSYSTEM_MODULE_INFORMATION;



PSYSTEM_MODULE GetKernelModuleInformation();
HANDLE LoadKernInAddrSpace();

int GetServiceCount();

DWORD GetKernelExportFuncAddr(PCHAR pFuncName);
DWORD GetServiceDataBase(DWORD dwPID);
DWORD GetServiceDataBaseWoW64(ULONGLONG baseAddr, ULONGLONG& DatabaseAddr);
DWORD GetBaseAddress(DWORD dwPID = NULL);
DWORD GetExportFuncRva(PCHAR pFileName,PCHAR pFuncName);
DWORD GetTextVitualOffset(PCHAR pFileName);
#endif