#ifndef _DEBUG_H__
#define _DEBUG_H__

#include <windows.h>
#include <stdio.h>

#define OARK_EXCEPTION(){                                \
	DisplayExceptionMsg(__FUNCTION__, __LINE__);         \
}

#define FLDRV_ERROR(x) {                                  \
	DisplayErrorMsg(x, __FUNCTION__, __LINE__);          \
}

VOID DisplayErrorMsg(PCHAR pMsg, PCHAR pFunctName, DWORD line);
VOID DisplayExceptionMsg(PCHAR pFunctName, DWORD line);
BOOL EnableDebugPrivilege( void );
#endif