#include <ntifs.h>
#include <ntddk.h>
#include <ntddstor.h>
#include <mountdev.h>
#include <ntddvol.h>
#include "..\common\common.h"
#include "vm.h"
// devctrl

NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, 
					 IN PUNICODE_STRING  RegistryPath);
__drv_dispatchType(IRP_MJ_DEVICE_CONTROL) DRIVER_DISPATCH FLDispatchDeviceControl;
NTSTATUS FLDispatchDeviceControl(__in PDEVICE_OBJECT DeviceObject, __in PIRP Irp);
void HookDrvUnload(IN PDRIVER_OBJECT DriverObject);
NTSTATUS HookDrvCreateClose(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
NTSTATUS HookDrvDefaultHandler(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);


#ifdef DBG
#define dprintf(fs, ...) DbgPrint("FLDEFEN: " fs, __VA_ARGS__)
#else
#define dprintf
#endif



//
// Process Specific Access Rights -- ժWRK
//
#define PROCESS_TERMINATE         (0x0001)  // winnt
#define PROCESS_CREATE_THREAD     (0x0002)  // winnt
#define PROCESS_SET_SESSIONID     (0x0004)  // winnt
#define PROCESS_VM_OPERATION      (0x0008)  // winnt
#define PROCESS_VM_READ           (0x0010)  // winnt
#define PROCESS_VM_WRITE          (0x0020)  // winnt
// begin_ntddk begin_wdm begin_ntifs
#define PROCESS_DUP_HANDLE        (0x0040)  // winnt
// end_ntddk end_wdm end_ntifs
#define PROCESS_CREATE_PROCESS    (0x0080)  // winnt
#define PROCESS_SET_QUOTA         (0x0100)  // winnt
#define PROCESS_SET_INFORMATION   (0x0200)  // winnt
#define PROCESS_QUERY_INFORMATION (0x0400)  // winnt
#define PROCESS_SET_PORT          (0x0800)
#define PROCESS_SUSPEND_RESUME    (0x0800)  // winnt

//inline hook 
void  HookObReferenceObjectByHandle();
void UnHookObReferenceObjectByHandle();

NTSTATUS HookInit();
NTSTATUS HookStart();
NTSTATUS HookStop();

//
