#include "HookDrv.h"
#include "hook.h"
#include "sync.h"


#ifdef ALLOC_PRAGMA
#pragma alloc_text(PAGE, HookInit)
#pragma alloc_text(PAGE, HookStart)
#pragma alloc_text(PAGE, HookStop)
#endif

/*ٻⱣ֤hookĿر*/
FAST_MUTEX KphSsMutex;
/* hookǷѾʼ. */
BOOLEAN KphSsInitialized = FALSE;
KPH_HOOK ObReferenceObjectByHandleeHook;




DWORD g_PidTobeProtct = 0;
OFFSETS g_Offsets;



extern POBJECT_TYPE *PsProcessType;

NTKERNELAPI NTSTATUS 
ObReferenceObjectByHandle(
						  IN HANDLE  Handle,
						  IN ACCESS_MASK  DesiredAccess,
						  IN POBJECT_TYPE  ObjectType  OPTIONAL,
						  IN KPROCESSOR_MODE  AccessMode,
						  OUT PVOID  *Object,
						  OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL
						  );
//HOOK
NTSTATUS DetourMyObReferenceObjectByHandle(
	IN HANDLE  Handle,
	IN ACCESS_MASK  DesiredAccess,
	IN POBJECT_TYPE  ObjectType  OPTIONAL,
	IN KPROCESSOR_MODE  AccessMode,
	OUT PVOID  *Object,
	OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL);
//

#ifdef _X86_
_declspec (naked) NTSTATUS OriginalObReferenceObjectByHandle(IN HANDLE  Handle,
															 IN ACCESS_MASK  DesiredAccess,
															 IN POBJECT_TYPE  ObjectType  OPTIONAL,
															 IN KPROCESSOR_MODE  AccessMode,
															 OUT PVOID  *Object,
															 OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL)
{

	_asm
	{   
		mov edi,edi
			push ebp
			mov ebp,esp

			mov eax,ObReferenceObjectByHandle
			add eax,5
			jmp eax                
	}

}
#endif

NTSTATUS DetourMyObReferenceObjectByHandle(
	IN HANDLE  Handle,
	IN ACCESS_MASK  DesiredAccess,
	IN POBJECT_TYPE  ObjectType  OPTIONAL,
	IN KPROCESSOR_MODE  AccessMode,
	OUT PVOID  *Object,
	OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL)
{
	NTSTATUS status;
#ifdef _X86_
	char* ImgFileName;
	DWORD Pid;
	_asm{
		pushad
			mov eax,fs:[0x124]
		//	mov eax,[eax+0x44]
		//	lea ebx,[eax+0x174]
		mov edi,g_Offsets.KPROCESS
			mov eax,[eax + edi]
		mov edi,g_Offsets.ImgFileName
			lea ebx,[eax + edi]

		mov ImgFileName,ebx
			//	mov edx,[eax+0x84]
			mov edi,g_Offsets.UniquePid
			mov edx,[eax + edi]

		mov Pid,edx
			popad
	}
	if(ObjectType== *PsProcessType)
	{
		//		DbgPrint("%s : %d The Pid to be protect is :%d\n",ImgFileName,Pid,g_PidTobeProtct);
		// 		if(DesiredAccess == PROCESS_TERMINATE)
		// 		{
		// 			if( _stricmp(ImgFileName,"notepad.exe") == 0)
		// 			{
		// 				DbgPrint("To be terminate %s %d\n",ImgFileName,Pid);
		// 				return STATUS_INVALID_HANDLE;
		// 			}
		// 			
		// 		}		
	}


	//ԭ
	status=OriginalObReferenceObjectByHandle(Handle,DesiredAccess,ObjectType,AccessMode,Object,HandleInformation);
	if((status==STATUS_SUCCESS)&&(DesiredAccess==PROCESS_TERMINATE))
	{   
		if(ObjectType== *PsProcessType)
		{
			DWORD *ptr = (DWORD*)((DWORD)(*Object) + g_Offsets.UniquePid);	//Pid ַ(XP:0x84 7:0xb4)
			DbgPrint("%s %d Ҫ %s %d\n ",ImgFileName,Pid, (char*)((ULONG)(*Object) + g_Offsets.ImgFileName),*ptr );
			if( *ptr == g_PidTobeProtct)
			{   
				ObDereferenceObject(*Object);
				return STATUS_INVALID_HANDLE;
			}
		}
	}
#endif
	return status;
}


NTSTATUS HookInit()
{
	NTSTATUS status = STATUS_SUCCESS;

	ExInitializeFastMutex(&KphSsMutex);

	return status;
}


NTSTATUS HookStart()
{
#ifdef _X86_
	NTSTATUS status = STATUS_SUCCESS;

	if( !OriginalObReferenceObjectByHandle)
		return STATUS_NOT_SUPPORTED;

//	_asm int 3

	ExAcquireFastMutex(&KphSsMutex);

	if (KphSsInitialized)
	{
		ExReleaseFastMutex(&KphSsMutex);
		return STATUS_UNSUCCESSFUL;
	}

	/*סObReferenceObjectByHandle*/
	KphInitializeHook(
		&ObReferenceObjectByHandleeHook,
		ObReferenceObjectByHandle,
		DetourMyObReferenceObjectByHandle);

	status = KphHook(&ObReferenceObjectByHandleeHook);

	if (!NT_SUCCESS(status))
	{
		ExReleaseFastMutex(&KphSsMutex);
		return status;
	}

	KphSsInitialized = TRUE;

	ExReleaseFastMutex(&KphSsMutex);

	return status;
#else
	return STATUS_NOT_SUPPORTED;

#endif
}

NTSTATUS HookStop()
{
#ifdef _X86_
	NTSTATUS status = STATUS_SUCCESS;

	ExAcquireFastMutex(&KphSsMutex);

	if (!KphSsInitialized)
	{
		ExReleaseFastMutex(&KphSsMutex);
		return STATUS_UNSUCCESSFUL;
	}

	status = KphUnhook(&ObReferenceObjectByHandleeHook);

	if (!NT_SUCCESS(status))
	{
		ExReleaseFastMutex(&KphSsMutex);
		return status;
	}

	KphSsInitialized = FALSE;

	ExReleaseFastMutex(&KphSsMutex);

	return status;
#else
	return STATUS_NOT_SUPPORTED;
#endif
}