// TestDllDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "TestDll.h"
#include "TestDllDlg.h"
#include "RotatingLog.h"


#pragma comment( linker, "/subsystem:console /entry:WinMainCRTStartup")

#pragma comment(lib,"..\\FLDefense\\Release\\lifedll.lib")



struct LifeDefenseFunAPIStu
{
	void *Start;
	void *Stop;
	void *UnInstall;
	void *FLSvcProtectOn;
	void *FLSvcProtectOff;
	void *FLSvcProtectCtrl;
	void *FLFilesProtectCtrl;
};
LifeDefenseFunAPIStu *LifedefenserFunAPI;

extern void * LifeDefenseFunAPI();
typedef int (*gStart)();
typedef int (*gStop)();
typedef void (*gUnInstall)();
typedef BOOL (*gFLSvcProtectOn)();
typedef BOOL (*gFLSvcProtectOff)();
typedef BOOL (*gFLSvcProtectCtrl)(BOOL bProtect);
typedef BOOL (*gFLFilesProtectCtrl)(BOOL bProtected);

gStart Start;
gStop Stop;
gUnInstall UnInstall;
gFLSvcProtectOn FLSvcProtectOn;
gFLSvcProtectOn FLSvcProtectOff;
gFLSvcProtectCtrl FLSvcProtectCtrl;
gFLFilesProtectCtrl FLFilesProtectCtrl;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CRotatingLog m_log(".\\aa.log",512,128);


//õԴڵĹرհť
VOID SetDebugConsole(
						VOID
						)
{
		HMENU menu;

		menu = GetSystemMenu(GetConsoleWindow(), FALSE);
		EnableMenuItem(menu, SC_CLOSE, MF_GRAYED | MF_DISABLED);
		DeleteMenu(menu, SC_CLOSE, 0);
}

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestDllDlg Ի




CTestDllDlg::CTestDllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDllDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestDllDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CTestDllDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CTestDllDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CTestDllDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CTestDllDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CTestDllDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CTestDllDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CTestDllDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CTestDllDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CTestDllDlg::OnBnClickedButton9)
END_MESSAGE_MAP()


// CTestDllDlg Ϣ

BOOL CTestDllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	LifedefenserFunAPI = (LifeDefenseFunAPIStu*)LifeDefenseFunAPI();
	Start = (gStart)LifedefenserFunAPI->Start;
	Stop = (gStop)LifedefenserFunAPI->Stop;
	FLSvcProtectOn = (gFLSvcProtectOn)LifedefenserFunAPI->FLSvcProtectOn;
	FLSvcProtectOff = (gFLSvcProtectOn)LifedefenserFunAPI->FLSvcProtectOff;
	FLSvcProtectCtrl = (gFLSvcProtectCtrl)LifedefenserFunAPI->FLSvcProtectCtrl;
	FLFilesProtectCtrl = (gFLFilesProtectCtrl)LifedefenserFunAPI->FLFilesProtectCtrl;
	UnInstall = (gUnInstall)LifedefenserFunAPI->UnInstall;

	//־¼
	m_log.AddLine("Begin log");

	//Դ
	SetDebugConsole();

	::SetWindowLong(GetSafeHwnd(), GWL_EXSTYLE, WS_EX_TOOLWINDOW); 

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CTestDllDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CTestDllDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CTestDllDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestDllDlg::OnBnClickedButton1()
{
	if( Start())
		AfxMessageBox("Start Sucess!");
	else
		AfxMessageBox("Start Failed!");

	m_log.AddLine("Start");

}

void CTestDllDlg::OnBnClickedButton2()
{
	if(Stop())
		AfxMessageBox("Stop Sucess!");
	else
		AfxMessageBox("Stop Failed!");

	m_log.AddLine("Stop");

}

void CTestDllDlg::OnBnClickedButton3()
{
	if( !FLSvcProtectOn())
		AfxMessageBox("Failed!");

	m_log.AddLine("FLSvcProtectOn");

}

void CTestDllDlg::OnBnClickedButton4()
{
	if( !FLSvcProtectOff())
		AfxMessageBox("Failed!");

	m_log.AddLine("FLSvcProtectOff");

}

void CTestDllDlg::OnBnClickedButton5()
{
	if( !FLSvcProtectCtrl(TRUE))
		AfxMessageBox("Failed!");

	m_log.AddLine("FLSvcProtectCtrl TRUE");

}

void CTestDllDlg::OnBnClickedButton6()
{
	if(!FLSvcProtectCtrl(FALSE))
		AfxMessageBox("Failed!");

	m_log.AddLine("FLSvcProtectCtrl FALSE");

}

void CTestDllDlg::OnBnClickedButton7()
{
	if(!FLFilesProtectCtrl(TRUE))
		AfxMessageBox("Failed!");

	m_log.AddLine("FLFilesProtectCtrl TRUE");
}

void CTestDllDlg::OnBnClickedButton8()
{
	if(!FLFilesProtectCtrl(FALSE))
		AfxMessageBox("Failed!");

	m_log.AddLine("FLFilesProtectCtrl FALSE");

}

void CTestDllDlg::OnBnClickedButton9()
{
	UnInstall();
}

BOOL CTestDllDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)

		if (pMsg->wParam==VK_ESCAPE || pMsg->wParam==VK_RETURN) //λسESC

			return TRUE;

	if (pMsg->message == WM_SYSKEYDOWN &&pMsg->wParam == VK_F4 ) //ALT+F4

		return TRUE;

	return CDialog::PreTranslateMessage(pMsg);
}
